﻿using VT.FW.DB;
using System;
using System.Collections.Generic;
using System.Text;

namespace Mall.Model.Entity.AppletWeChat
{
    /// <summary>
    /// 直播房间信息
    /// </summary>
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Live_House
    {
        /// <summary>
        /// 房间号
        /// </summary>
        public int ID { get; set; }

        /// <summary>
        /// 商户id
        /// </summary>
        public int TenantId { get; set; }

        /// <summary>
        /// 小程序id
        /// </summary>
        public int MallBaseId { get; set; }


        public DateTime CreateDate { get; set; }

        /// <summary>
        /// 房间名
        /// </summary>
        public string name { get; set; }
        /// <summary>
        /// 房间id
        /// </summary>
        public string roomid { get; set; }

        /// <summary>
        /// 直播间背景墙
        /// </summary>
        public string cover_img { get; set; }
        /// <summary>
        /// 直播状态
        /// </summary>

        public string live_status { get; set; }

        /// <summary>
        /// 直播计划开始时间
        /// </summary>

        public string start_time { get; set; }

        /// <summary>
        /// 直播计划开始时间
        /// </summary>

        public DateTime? LiveTime { get; set; }

        /// <summary>
        /// 直播计划结束时间
        /// </summary>
        public string end_time { get; set; }
        /// <summary>
        /// 主播名
        /// </summary>
        public string anchor_name { get; set; }
        /// <summary>
        /// 主播图片
        /// </summary>
        public string anchor_img { get; set; }

        /// <summary>
		/// 二维码大小
		/// </summary>
		public int? LiveQrCodeSize { get; set; }

        /// <summary>
        /// 二维码上间距
        /// </summary>
        public int? LiveQrCodePaddingTop { get; set; }

        /// <summary>
        /// 二维码左间距
        /// </summary>
        public int? LiveQrCodePaddingLeft { get; set; }

        /// <summary>
        /// 二维码形状(0-圆形，1-方形)
        /// </summary>
        public int? LiveQrCodeType { get; set; }
    }
}
